package net.vtstar.zhongtong.avi.gateway.painting.job;

import lombok.extern.slf4j.Slf4j;
import net.vtstar.scada.base.equipmgt.domain.Enum.EquipStatusEnum;
import net.vtstar.scada.base.gather.domain.EquipmentData;
import net.vtstar.scada.base.gather.job.GatherJob;
import net.vtstar.zhongtong.avi.gateway.painting.domain.PaintingRobotMachine;
import net.vtstar.zhongtong.avi.gateway.welding.domain.PlateChainMachine;
import org.quartz.JobExecutionContext;
import org.quartz.JobExecutionException;
import org.springframework.stereotype.Component;

/**
 * 涂装机器人数据采集JOB
 */
@Slf4j
@Component
public class PaintingRobotMachineJob extends GatherJob {

    private static final String NAME = "PAINTING_ROBOT";

    @Override
    protected void executeInternal(JobExecutionContext context) throws JobExecutionException {

        log.info("JobName: {}", context.getJobDetail().getKey().getName());
        super.gatherByModbus(NAME, PaintingRobotMachine.class);
    }

    public boolean handleObject(EquipmentData equipmentData) {
        PaintingRobotMachine data = (PaintingRobotMachine) equipmentData;
        Integer state = data.getState();
        if (state == null) {
            return false;
        }
        switch (state) {
            case 0:
                equipmentData.setEquipStatus(EquipStatusEnum.SHUTDOWN);
                break;
            case 1:
                equipmentData.setEquipStatus(EquipStatusEnum.RUN);
                break;
            case 2:
                equipmentData.setEquipStatus(EquipStatusEnum.ALARM);
                break;
            default:
                return false;
        }
        return true;
    }

    @Override
    public Object handleValue(String fieldName, Object value) {
        return value;
    }
}
